package com.netmera.netmera_flutter_sdk;

import com.netmera.data.NMInboxStatus;
import com.netmera.data.NMInboxStatusCount;

import java.util.HashMap;

/**
 * Copyright (c) 2019 Inomera Research.
 *
 * @author Burak Soykal
 */
class FNMInboxStatusCount {

    public static HashMap<String, Object> parseInboxCountForStatusToMap(NMInboxStatusCount nmInboxStatusCount) {
        Integer allCount = nmInboxStatusCount.getCountForStatus(NMInboxStatus.STATUS_ALL);
        Integer deletedCount = nmInboxStatusCount.getCountForStatus(NMInboxStatus.STATUS_DELETED);
        Integer readCount = nmInboxStatusCount.getCountForStatus(NMInboxStatus.STATUS_READ);
        Integer unreadCount = nmInboxStatusCount.getCountForStatus(NMInboxStatus.STATUS_UNREAD);

        if (allCount == null) allCount = 0;
        if (deletedCount == null) deletedCount = 0;
        if (readCount == null) readCount = 0;
        if (unreadCount == null) unreadCount = 0;

        HashMap<String, Object> map = new HashMap<>();
        map.put(String.valueOf(NMInboxStatus.STATUS_ALL.getCode()), allCount);
        map.put(String.valueOf(NMInboxStatus.STATUS_DELETED.getCode()), deletedCount);
        map.put(String.valueOf(NMInboxStatus.STATUS_READ.getCode()), readCount);
        map.put(String.valueOf(NMInboxStatus.STATUS_UNREAD.getCode()), unreadCount);
        return map;
    }

    public static NMInboxStatus getInboxStatus(int code) {
        for (NMInboxStatus value : NMInboxStatus.values()) {
            if (value.getCode() == code) {
                return value;
            }
        }
        return NMInboxStatus.STATUS_ALL;
    }
}
