package com.netmera.netmera_flutter_sdk;

import com.google.gson.Gson;
import com.google.gson.JsonObject;
import com.netmera.NetmeraCategory;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Copyright (c) 2019 Inomera Research.
 *
 * @author Burak Soykal
 */
class FNetmeraCategoryObject {

    static List<HashMap<String, Object>> mapCategoryObjects(List<NetmeraCategory> categoryObjects) {
        List<HashMap<String, Object>> categoryObjectList = new ArrayList<>();
        for (NetmeraCategory category : categoryObjects) {
            categoryObjectList.add(getCategoryObjectMap(category));
        }
        return categoryObjectList;
    }

    private static HashMap<String, Object> getCategoryObjectMap(NetmeraCategory category) {
        HashMap<String, Object> map = new HashMap<>();
        map.put("category_name", category.getCategoryName());
        map.put("category_status", new Gson().toJson(category.getStatus(), JsonObject.class));
        map.put("category_read_count", category.getReadCount());
        map.put("category_unread_count", category.getUnReadCount());
        map.put("category_deleted_count", category.getDeletedCount());
        map.put("category_last_message", new Gson().toJson(FNetmeraPushObject.getPushObjectMap(category.getLastMessage())));

        return map;
    }
}
