/**
 * Copyright (c) 2019 Inomera Research.
 * @author Burak Soykal
 */

#import "FNetmeraCategoryObject.h"
#import "FNetmeraPushObject.h"

@implementation FNetmeraCategoryObject


+(NSArray<NSDictionary*>*) mapCategoryObjects: (NSMutableArray<NetmeraInboxCategoryObject *>*) categoryObjects {
    NSMutableArray<NSDictionary*> *categoryObjectList = [[NSMutableArray alloc]init];
    for (int i = 0; i < [categoryObjects count]; i++) {
        [categoryObjectList addObject: [self getCategoryObjectMap:categoryObjects[i]]];
    }
    return categoryObjectList;
}

+(NSDictionary*) getCategoryObjectMap:(NetmeraInboxCategoryObject*) categoryObject {
    NSMutableDictionary *data = [NSMutableDictionary dictionary];
    [data setValue:[categoryObject categoryName] forKey:@"category_name"];
    [data setValue:@([[categoryObject status] readCount]) forKey:@"category_read_count"];
    [data setValue:@([[categoryObject status] unreadCount]) forKey:@"category_unread_count"];
    [data setValue:@([[categoryObject status] deletedCount]) forKey:@"category_deleted_count"];
    NSDictionary * lastMsg = [FNetmeraPushObject getPushObjectMap:[categoryObject lastMessage]] ;
    
    NSError *error;
    NSData *dataxx = [NSJSONSerialization dataWithJSONObject:lastMsg options:0 error:&error];
    NSString *jsonStr = [[NSString alloc] initWithData:dataxx encoding:NSUTF8StringEncoding];
    
    [data setValue:jsonStr forKey:@"category_last_message"];
//    [data setValue:[jsonData toJSONString] forKey:@"category_status"];


    return data;
}


@end
