import 'package:netmera_flutter_sdk/events/NetmeraEvent.dart';

import 'NetmeraLineItem.dart';

///
/// Copyright (c) 2019 Inomera Research.
/// Author Burak Soykal
///
class NetmeraEventPurchase extends NetmeraEvent {
  @override
  getCode() => "n:ph";

  double? _subTotal;
  double? _grandTotal;
  int? _itemCount;
  int? _productCount;
  List<NetmeraLineItem>? _lineItems;
  String? _paymentMethod;
  double? _shippingCost;
  double? _discount;
  String? _coupon;

  setSubTotal(double value) {
    _subTotal = value;
  }

  double? getSubTotal() => _subTotal;

  setGrandTotal(double value) {
    _grandTotal = value;
  }

  double? getGrandTotal() => _grandTotal;

  setItemCount(int value) {
    _itemCount = value;
  }

  int? getItemCount() => _itemCount;

  setProductCount(int value) {
    _productCount = value;
  }

  int? getProductCount() => _productCount;

  setLineItems(List<NetmeraLineItem> value) {
    _lineItems = value;
  }

  List<NetmeraLineItem>? getLineItems() => _lineItems;

  setPaymentMethod(String value) {
    _paymentMethod = value;
  }

  String? getPaymentMethod() => _paymentMethod;

  setShippingCost(double value) {
    _shippingCost = value;
  }

  double? getShippingCost() => _shippingCost;

  setDiscount(double value) {
    _discount = value;
  }

  double? getDiscount() => _discount;

  setCoupon(String value) {
    _coupon = value;
  }

  String? getCoupon() => _coupon;

  @override
  Map<String, Object?> toJson() {
    Map<String, Object?> map = super.toJson();

    List<Map<String, Object?>> lineItemMap = new List.empty(growable: true);
    for (NetmeraLineItem item in _lineItems!) {
      lineItemMap.add(item.toJson());
    }

    map['er'] = _subTotal;
    map['es'] = _grandTotal;
    map['ec'] = _itemCount;
    map['fz'] = _productCount;
    map['items'] = lineItemMap;
    map['em'] = _paymentMethod;
    map['ep'] = _shippingCost;
    map['el'] = _discount;
    map['ek'] = _coupon;
    return map;
  }
}
