import 'package:netmera_flutter_sdk/events/NetmeraEvent.dart';

///
/// Copyright (c) 2019 Inomera Research.
/// Author Burak Soykal
///
abstract class NetmeraEventContent extends NetmeraEvent {
  static const int TYPE_OTHER = 0;
  static const int TYPE_IMAGE = 1;
  static const int TYPE_AUDIO = 2;
  static const int TYPE_VIDEO = 3;
  static const int TYPE_TEXT = 4;

  String? _id;
  String? _name;
  int? _type;
  String? _provider;
  List<String>? _categoryIds;
  List<String>? _categoryNames;
  List<String>? _keywords;

  String? getId() => _id;

  setId(String value) {
    _id = value;
  }

  String? getName() => _name;

  setName(String value) {
    _name = value;
  }

  int? getType() => _type;

  setType(int value) {
    _type = value;
  }

  String? getProvider() => _provider;

  setProvider(String value) {
    _provider = value;
  }

  List<String>? getCategoryIds() => _categoryIds;

  setCategoryIds(List<String> value) {
    _categoryIds = value;
  }

  List<String>? getCategoryNames() => _categoryNames;

  setCategoryNames(List<String> value) {
    _categoryNames = value;
  }

  List<String>? getKeywords() => _keywords;

  setKeywords(List<String> value) {
    _keywords = value;
  }

  @override
  Map<String, Object?> toJson() {
    Map<String, Object?> map = super.toJson();
    map['ea'] = _id;
    map['eb'] = _name;
    map['ed'] = _type;
    map['ee'] = _provider;
    map['ga'] = _categoryIds;
    map['ef'] = _categoryNames;
    map['eg'] = _keywords;
    return map;
  }
}
